#include<bits/stdc++.h>
using namespace std;
long long Razlika(int n,long long a[])
{
   long long raz1=100000000000,raz2;
   for(int i=0;i<n-1;i++)
   {
      if(raz1>abs(a[i]-a[i+1]))
      {
          raz2=raz1;
          raz1=abs(a[i]-a[i+1]);
      }
   }
   while(raz2!=raz1)
   {
       if(raz1>raz2)
       {
           swap(raz2,raz1);
       }
       raz2=raz2-raz1;
   }
   for(int i=0;i<n-1;i++)
   {
       if(abs(a[i]-a[i+1])%raz1!=0)
       {
           raz1=0;
           break;
       }
   }
   return raz1;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int T;
    cin>>T;
    for(int i=0;i<T;i++)
    {
        int n,m;
        long long x,y;
        cin>>n>>m;
        long long a[n];
        long long b[m];
        for(int i=0;i<n;i++)
        {
            cin>>a[i];
        }
        for(int i=0;i<m;i++)
        {
            cin>>b[i];
        }
        x=Razlika(n,a);
        if(x==1 || x==0)
        {
            cout<<0<<endl;
        }
        y=Razlika(m,b);
        int p=(b[0]%y)%x,k=y%x,c=a[0]%x;
        if((c-p)%k==0 && c-p!=0)
        {
            cout<<0<<endl;
        }
        else
        {
            cout<<1<<endl;
        }
        
    }
    return 0;
}